#pragma comment(linker, "/STACK:512000000")
#include <string>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

char mem[450000000];
int pt = 0;
void* operator new(size_t n)
{
	pt += n;
	return (void*)(mem + pt - n);
}
void operator delete(void* ignored)
{}

const int sz = 201 * 256 * 256;

int n, m, l;
vector<int> al[sz];
char used[sz];

inline int pack(int x, int y, int i) {
	return (((x << 8) | y) << 8) | i;
}

inline pair<int, int> unpack(int u) {
	u >>= 8;
	return { u >> 8, u & 255 };
}

const int dx[4] = { 0, 0, -1, 1 };
const int dy[4] = { -1, 1, 0, 0 };

vector<int> st;
vector<int> cycle;
string field[201];
vector<pair<int, int>> ans;

inline char getdir(pair<int, int> &a, pair<int, int> &b) {
	if (b.first == a.first + 1) {
		return 'D';
	}
	if (b.first == a.first - 1) {
		return 'U';
	}
	if (b.second == a.second + 1) {
		return 'R';
	}
	return 'L';
}

void dfs(int u) {
	used[u] = 1;
	st.push_back(u);
	for (int v : al[u]) {
		if (used[v] == 0) {
			dfs(v);
		}
		else if (used[v] == 1) {
			while (st.back() != v) {
				cycle.push_back(st.back());
				st.pop_back();
			}
			cycle.push_back(st.back());
			st.pop_back();

			reverse(cycle.begin(), cycle.end());

			int frst = 0;
			for (int i = cycle.size() - 1; i >= 0; i--) {
				if ((cycle[i] & 255) == 0) {
					frst = i;
				}
			}

			for (int i = cycle.size() - 1; i >= 0; --i) {
				int ii = frst - i;
				if (ii < 0)
					ii += cycle.size();
				ans.push_back(unpack(cycle[ii]));
			}

			//for (auto p : ans) {
			//	cout << p.first + 1 << " " << p.second + 1 << endl;
			//}

			string res = "";
			res.reserve(ans.size());

			res.push_back(getdir(ans.back(), ans[0]));
			for (int i = 1; i < ans.size(); i++) {
				res.push_back(getdir(ans[i - 1], ans[i]));
			}
			printf("YES\n%d\n%d %d\n%s\n", res.length(), ans.back().first + 1, ans.back().second + 1, res.c_str());

			exit(0);
		}
	}
	used[u] = 2;
	st.pop_back();
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	srand(239239);
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m >> l;
	for (int i = 0; i < n; i++) {
		cin >> field[i];
	}
	string pattern;
	cin >> pattern;

	ans.reserve(n * m * l + 200);
	st.reserve(n * m * l + 200);
	cycle.reserve(n * m * l + 200);

	for (int x = 0; x < n; x++) {
		for (int y = 0; y < m; y++) {
			for (int i = 0; i < l; i++) {
				int u = pack(x, y, i);
				int ii = i + 1;
				if (ii == l)
					ii = 0;
				for (int d = 0; d < 4; d++) {
					int xx = x + dx[d];
					int yy = y + dy[d];
					if (0 <= xx && xx < n && 0 <= yy && yy < m && field[xx][yy] == pattern[ii]) {
						al[u].push_back(pack(xx, yy, ii));
					}
				}
			}
		}
	}
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			for (int k = 0; k < l; ++k)
			{
		int ma = pack(i, j, k);
		if (!used[ma])
			dfs(ma);
			}

	cout << "NO" << endl;

	return 0;
    } //KEKEKKEKE