import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class J {
	char[] sc, tc;
	long[] hs, ht;
	int n;
	long x = 617;
	/*
	public boolean equals(int s, int t, int l) {
		for (int i = 0; i < l; i++) {
			if (sc[s + i] != tc[t + i]) {
				return false;
			}
		}
		return true;
	}
	*/
	public boolean equals(int s, int t, int l) {
		return sHash(s, l) == tHash(t, l);
	}
	
	public long sHash(int s, int l) {
		return hs[s + l] - hs[s] * pow(x, l);
	}
	
	public long tHash(int s, int l) {
		return ht[s + l] - ht[s] * pow(x, l);
	}
	
	public long pow(long a, int b) {
		if (b == 0) {
			return 1;
		}
		if (b == 1) {
			return a;
		}
		if (b % 2 == 0) {
			long r = pow(a, b / 2);
			return r * r;
		}
		long r = pow(a, b / 2);
		return r * r * a;
	}
	
	public boolean f(int s, int t, int l) {
		if (l == 0) {
			return true;
		}
		for (int i = 0; i < l - 1; i++) {
			if (equals(s + i, t, l - i)) {
				if (f(s, t + l - i, i)) {
					return true;
				}
			}
		}
		return false;
	}
	
    public void solve() throws IOException {
    	n = nextInt();
        sc = nextToken().toCharArray();
        tc = nextToken().toCharArray();
        hs = new long[n + 1];
        ht = new long[n + 1];
        for (int i = 1; i <= n; i++) {
        	hs[i] = hs[i - 1] * x + sc[i - 1];
        }
        for (int i = 1; i <= n; i++) {
        	ht[i] = ht[i - 1] * x + tc[i - 1];
        }
        if (f(0, 0, n)) {
        	out.print("Yes");
        } else {
        	out.print("No");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new J().run();
    }

}
