#include <iostream>
#include <vector>
#include <cstring>
#include <sstream>

using namespace std;

typedef long long ll;

const ll x = 37;
const ll MOD = 1e9 + 7;
const int MAXN = 1e4;

ll x_pow[MAXN];

void init_pow() {
	x_pow[0] = 1;
	for (int i = 1; i < MAXN; i++)
		x_pow[i] = (x_pow[i - 1] * x) % MOD;
}

struct my_string {
	int n;
	string s;
	vector <ll> h;
	my_string(string s = "") : n(int(s.length())), s(s) {
		h.resize(n + 1);
		h[0] = 0;
		for (int i = 1; i <= n; i++)
			h[i] = (h[i - 1] * x + s[i - 1]) % MOD;
	}

	ll hash(int i, int j) {
		return (h[j + 1] - (h[i] * x_pow[j - i + 1]) % MOD + MOD) % MOD;
	}
};

bool dp[MAXN];

int main() {
	int n; cin >> n;
	string s1, s2; cin >> s1 >> s2;
	
	init_pow();

	my_string m1(s1), m2(s2);

	dp[0] = true;
	for (int i = 1; i <= n; i++)
		for (int j = 0; j < i; j++)
			if (m1.hash(j, i - 1) == m2.hash(m2.n - i, m2.n - j - 1))
				dp[i] |= dp[j];

	if (dp[n])
		cout << "Yes" << endl;
	else
		cout << "No" << endl;

	return 0;
}