#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <sstream>

using namespace std;

typedef long long ll;

const int x = 37;
const int MOD = 1e9 + 7;
const int MAXN = 5e3;

int x_pow[MAXN];

void init_pow() {
	x_pow[0] = 1;
	for (int i = 1; i < MAXN; i++)
		x_pow[i] = ((ll)x_pow[i - 1] * (ll)x) % MOD;
}

struct my_string {
	int n;
	string s;
	int h[MAXN + 1];
	my_string(string s = "") : n(int(s.length())), s(s) {
		h[0] = 0;
		for (int i = 1; i <= n; i++)
			h[i] = ((ll)h[i - 1] * x + s[i - 1]) % MOD;
	}

	inline int hash(int i, int j) {
		return (h[j + 1] - ((ll)h[i] * x_pow[j - i + 1]) % MOD + MOD) % MOD;
	}
};

bool dp[MAXN];

vector <int> y;

int a[MAXN];
int b[MAXN][MAXN];

int main() {
	//freopen("input.txt", "r", stdin);
	int n; cin >> n;
	string s1, s2; cin >> s1 >> s2;
	
	init_pow();

	my_string m1(s1), m2(s2);

	for (int i = n - 1; i >= 0; i--)
		for (int j = n - 1; j >= 0; j--) {
			if (j != n - 1)
				b[i][j] = (b[i + 1][j + 1] + 1) * (s1[i] == s2[j]);
			else
				b[i][j] = (s1[i] == s2[j]);
		}
	fill(a, a + MAXN, 0);
	for (int i = 0; i < n; i++) {
		int j = n - i - 1;
		for (int p = 0; p <= j; p++)
			if (b[i][p] >= j - p + 1)
				a[i] = max(a[i], j - p + 1);
	}

	dp[0] = true;
	for (int i = 1; i <= n; i++)
		for (int j = 0; j < i; j++) {
			if (a[j] >= i - j)
				dp[i] |= dp[j];
		}

	if (dp[n])
		cout << "Yes" << endl;
	else
		cout << "No" << endl;

	return 0;
}