import java.io.*;
import java.math.BigInteger;
import java.util.ArrayDeque;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by spb on 23.10.2016.
 */

/*
4
0 R
0 U
0 L
5 D

7
0 U
0 D
1 L
1 D
2 D
2 R
2 U
 */

public class TaskB {

    String fileName = "";

    public void solve() throws IOException {
        int n = nextInt();
        int[] t = new int[n];
        char[] d = new char[n];
        for (int i = 0; i < n; i++) {
            t[i] = nextInt();
            d[i] = nextToken().charAt(0);
        }

        ArrayDeque<Integer>[] q = new ArrayDeque[300];
        q['U'] = new ArrayDeque<>();
        q['D'] = new ArrayDeque<>();
        q['R'] = new ArrayDeque<>();
        q['L'] = new ArrayDeque<>();

        int[] ans = new int[n];
        Arrays.fill(ans, -1);

        final char[] cs = {'U', 'L', 'R', 'D'};

        int cur = -1;
        int time = t[0];
        boolean[] canMove = new boolean[300];
        while (cur < n) {

            if (!q['U'].isEmpty() && !q['L'].isEmpty() && !q['R'].isEmpty() && !q['D'].isEmpty()) {
                break;
            }
            if (cur == n - 1 && q['U'].isEmpty() && q['L'].isEmpty() && q['R'].isEmpty() && q['D'].isEmpty()) {
                break;
            }

            while (cur + 1 < n && t[cur + 1] <= time) {
                cur++;
                q[d[cur]].push(cur);
            }

            for (char c : cs) canMove[c] = false;

            for (char c : cs) {
                char r = right(c);
                if (!q[c].isEmpty() && q[r].isEmpty()) {
                    canMove[c] = true;
                }
            }
            for (char c : cs) {
                if (canMove[c]) {
                    int idx = q[c].poll();
                    ans[idx] = time;
                }
            }

            if (cur != n - 1 && q['U'].isEmpty() && q['L'].isEmpty() && q['R'].isEmpty() && q['D'].isEmpty()) {
                cur++;
                time = t[cur];
                q[d[cur]].push(cur);
            } else {
                time++;
            }
        }

        StringBuilder builder = new StringBuilder();
        for (int an : ans) {
            builder.append(an).append('\n');
        }
        out.println(builder);
    }

    char right(char c) {
        if (c == 'U') return 'L';
        if (c == 'L') return 'D';
        if (c == 'R') return 'U';
        if (c == 'D') return 'R';
        return ' ';
    }

    public void run() {
        try {
            if (fileName.length() == 0) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out);
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskB().run();
    }

}
