import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

/*
4 1000
100 200 200 800

4 0
100 200 800 200
 */

public class TaskE {
    String fileName = "";

    public void solve() throws IOException {
        int n = nextInt();
        long k = nextLong();
        long[] s = new long[n];
        for (int i = 0; i < n; i++) {
            s[i] = nextLong();
        }

        Arrays.sort(s);
        long last = s[n - 1];

        long[] d = new long[n]; // if bound after i
        Arrays.fill(d, Long.MAX_VALUE / 10);
        d[n - 1] = (last + k) * n;

        for (int i = n - 2; i > -1; i--) {

            for (int prevBound = i + 1; prevBound < n; prevBound++) {
                long cur = d[prevBound] + (long) (n - i - 1) * k - (long) (i + 1) * (s[prevBound] - s[i]);

                if (cur < d[i]) {
                    d[i] = cur;
                }
            }
        }

        long min = d[0];
        for (long i : d) min = Math.min(min, i);
        out.println(min);
    }

    public void run() {
        try {
            if (fileName.length() == 0) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out, true);
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskE().run();
    }

}
