import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class TaskI {
    String fileName = "";

    ArrayList<Next>[] graph;

    public void solve() throws IOException {
        int n = nextInt(), m = nextInt();
        graph = new ArrayList[n];
        HashMap<Integer, Integer>[] map = new HashMap[n];
        for (int i = 0; i < n; i++) {
            graph[i] = new ArrayList<>();
            map[i] = new HashMap<>();
        }

        for (int i = 0; i < m; i++) {
            int u = nextInt() - 1, v = nextInt() - 1;
            Next edge = new Next(v, i);
            graph[u].add(edge);
            map[u].put(v, i);
        }

        int l = 0, r = m + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            vis = new boolean[n];
            time = new int[n];
            tlast = 0;
            for (int i = 0; i < n; i++) {
                if (!vis[i]) {
                    topsort(i, mid);
                }
            }
            int[] res = new int[n];
            for (int i = 0; i < n; i++) {
                res[time[i]] = i;
            }
            boolean ok = true;
            for (int i = 0; i < n - 1; i++) {
                if (!map[res[i + 1]].containsKey(res[i]) || map[res[i + 1]].get(res[i]) >= mid) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (r != m + 1) {
            out.println(r);
        } else {
            out.println(-1);
        }
    }

    boolean[] vis;
    int[] time;
    int tlast;

    public void topsort(int v, int t) {
        vis[v] = true;
        for (Next edge : graph[v]) {
            if (!vis[edge.v] && edge.time < t) {
                topsort(edge.v, t);
            }
        }
        time[v] = tlast;
        tlast++;
    }

    class Next {
        int v, time;

        public Next(int v, int time) {
            this.v = v;
            this.time = time;
        }
    }

    public void run() {
        try {
            if (fileName.length() == 0) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out, true);
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskI().run();
    }

}
